#include <windows.h>
#include <shlwapi.h>
#include <d3d9.h>

#ifndef _DEBUG
extern "C"
int _fltused = 1;
#endif

// ---------------- ev ----------------

// DWORD
__inline
DWORD TamperDword(DWORD addr, DWORD target)
{
	DWORD old = *(DWORD*)addr;
	*(DWORD*)addr = target;
	return old;
}

// DWORDZ
__inline
DWORD TamperDwordAdd(DWORD addr, DWORD delta)
{
	DWORD old = *(DWORD*)addr;
	*(DWORD*)addr += delta;
	return old;
}

// NEAR JMPIyh
__inline
DWORD TamperNearJmpOpr(DWORD addr, DWORD target)
{
	DWORD old = *(DWORD*)(addr + 1) + (addr + 5);
	*(DWORD*)(addr + 1) = target - (addr + 5);
	return old;
}

// NEAR JMP
__inline
void TamperNearJmp(DWORD addr, DWORD target)
{
	*(PBYTE)(addr + 0) = 0xE9;
	TamperNearJmpOpr(addr, target);
}

// NEAR CALL
__inline
void TamperNearCall(DWORD addr, DWORD target)
{
	*(PBYTE)(addr + 0) = 0xE8;
	TamperNearJmpOpr(addr, target);
}

// tHgfBXNv^
#pragma pack(push, 4)
struct SWRFONTDESC {
	char FaceName[0x100];
	BYTE R1;
	BYTE R2;
	BYTE G1;
	BYTE G2;
	BYTE B1;
	BYTE B2;
	LONG Height;
	LONG Weight;
	BYTE Italic;
	BYTE Shadow;
	BYTE UseOffset;
	DWORD BufferSize;
	DWORD OffsetX;
	DWORD OffsetY;
	DWORD CharSpaceX;
	DWORD CharSpaceY;
};

// RpNg
struct SWRSTR {
	union {
		char  str[16];
		char* pstr;
	};
	size_t length;

	operator char *() {
		return length > 15 ? pstr : str;
	}
};

// GtFNg}l[WC^[tF[X
struct IEffectManager {
	virtual void* Destruct(int dynamic) = 0;
	virtual void LoadPattern(LPCSTR fileName, int) = 0;
	virtual void ClearPattern() = 0;
	virtual void AppendRegion(int arg_0, float arg_4, float arg_8, char arg_c, char arg_10, int arg_14) = 0;
	virtual void ClearRegion() = 0;
};

// 悭킩Ȃ
struct UnknownF {
	void *Unknown[3];
	float Aaxis;
	float Baxis;
};

// static_assert
template<bool value>
struct static_assert { typedef struct assert_failed Type; };
template<>
struct static_assert<true> { typedef void* Type; };

// union_cast
template<typename TDest, typename TSrc>
__forceinline 	
TDest union_cast(TSrc src) {
	static_assert<sizeof(TDest) == sizeof(TSrc)>::Type 
		size_mismatch = 0;
	union {  TDest dst; TSrc src; } c;
	c.src = src;
	return c.dst;
}

// thiscall
class C {};
#define Ccall(p,f,r,T) (((C*)p)->*union_cast<r##(C::*)##T>(f))

// tHgIuWFNg\bh
#define SWRFont_Create(p) \
	Ccall(p,0x410E50,void,())()
#define SWRFont_Destruct(p) \
	Ccall(p,0x410EE0,void,())()
#define SWRFont_SetIndirect(p, pdesc) \
	Ccall(p,0x410FC0,void,(void*))(pdesc)

// eNX`}l[W\bh
#define CTextureManager_LoadTexture(p, ret, path, unk1, unk2) \
	Ccall(p,0x4050D0,int*,(int*, LPCSTR, void*, void*))(ret, path, unk1, unk2)
#define CTextureManager_CreateTextTexture(p, ret, str, pdesc ,width ,height) \
	Ccall(p,0x405140,int*,(int*, LPCSTR, void*, int, int))(ret, str, pdesc, width, height)
#define CTextureManager_Remove(p, id) \
	Ccall(p,0x4051B0,void*,(int))(id)
#define CTextureManager_SetTexture(p, id, stage) \
	Ccall(p,0x405230,void,(int, int))(id, stage)
#define CTextureManager_GetSize(p, w, h) \
	Ccall(p,0x4052A0,void,(int*, int*))(w, h)
// eNX`}l[W\bh(nh}l[W̌p)
#define CTextureManager_Get(p, id) \
	((IDirect3DTexture9**)CHandleManager_Get(p, id))
#define CTextureManager_Allocate(p, id) \
	((IDirect3DTexture9**)CHandleManager_Allocate(p, id))
#define CTextureManager_Deallocate(p, id) \
	CHandleManager_Deallocate((void *)p, id)

// nh}l[W\bh
#define CHandleManager_Get(t, p, id) \
	Ccall(p,0x4026C0,t*,(int))(id)
 __declspec(naked) void**
Thunk_CHandleManager_Allocate(void *p, int *ret) {
	// thiscallȂ̂ɗƎvedigĂł@̊
	__asm push edi
	__asm mov edi, [esp+8]
	__asm push [esp+12]
	__asm mov eax, 0x405520
	__asm call eax
	__asm pop edi
	__asm retn
 }
#define CHandleManager_Allocate(p, ret) \
	Thunk_CHandleManager_Allocate(p, ret)
 __declspec(naked) void
Thunk_CHandleManager_Deallocate(void *p, int id) {
	 // thiscall()eaxgĂł@̊
	__asm mov eax, [esp+4]
	__asm push [esp+8]
	__asm mov ecx, 0x402610
	__asm call ecx
	__asm retn
 }
#define CHandleManager_Deallocate(p, id) \
	Thunk_CHandleManager_Deallocate(p, id)

// _\bh
#define CRenderer_Begin(p)  \
	Ccall(p,0x401000,bool,())()
#define CRenderer_End(p) \
	Ccall(p,0x401040,void,())()

// ZNgGtFNg}l[W\bh
#define CSelectEffectManager_Create_Address 0x420FF0
#define CSelectEffectManager_Free_Address   0x422830
#define CSelectEffectManager_Create(p) \
	Ccall(p, CSelectEffectManager_Create_Address, void, ())()

// Cvbg}l[W\bh
#define CInputManager_ReadReplay(p, name) \
	Ccall(p, 0x42BD20, bool,(char *))(name)

// xN^IuWFNg
#define Vector_Create \
	((void (__stdcall *)(void *, size_t, size_t, int, int))0x67B94C)
#define Vector_Destruct \
	((void (__stdcall *)(void *, size_t, size_t, int))0x67B8E9)

// VXeL[Vbg
#define CheckKeyOneshot  \
	((bool(*)(int, int, int, int))0x439CE0)

// pbg[h
#define LoadPackagePalette(pflag, name, pal, bpp) \
	Ccall(pflag, 0x408F00, void, (LPCSTR, void *, int))(name, pal, bpp)

// LN^̎擾
#define GetCharacterAbbr \
	((LPCSTR (__cdecl *)(int id))0x43B080)

// og[hݒ
#define SetBattleMode \
	((void (__cdecl *)(int comm, int sub))0x43AA30)

// eNX`}l[W
// CHandleManager<IDirect3DTexture *>
#define g_textureMgr ((void *)0x6ECD40)
// Direct3DfoCX
// IDirect3DDevice9*
#define g_pd3dDev    (*((IDirect3DDevice9**)0x6ED250))
// _
// CRenderer
#define g_renderer   ((void *)0x6E3DBC)
// lbg[NIuWFNg
// CNetworkServer/CNetworkClient
#define g_pnetObject (*(char**)0x6E62FC)
// vt@C
// char *
#define g_pprofP1 ((char*)(g_pnetObject + 0x04))
#define g_pprofP2 ((char*)(g_pnetObject + 0x24))
// UDPlbg[NIuWFNg
// CNetworkBase
#define g_pnetUdp    (g_pnetObject + 0x3B4)
// sA
// vector<SWRClientInfo> ?
#define g_psvClients (g_pnetUdp + 0xFC)
// T[oAhX
// in_addr
#define g_ptoAddr    (g_pnetUdp + 0x2C)
// og}l[W
// CBattleManager *
#define g_pbattleMgr (*(void **)0x6E6244)
// CtH}l[W
// CInfoManager *
#define g_pinfoMgr   (*(void **)0x6E6248)
// [h
// int
#define g_commMode   (*(DWORD*)0x6E62EC)
#define g_subMode    (*(DWORD*)0x6E62E4)
#define g_menuMode   (*(DWORD*)0x6D094C)
// V[ID
// DWORD
#define g_sceneIdNew (*(DWORD*)0x6ECE78)
#define g_sceneId    (*(DWORD*)0x6ECE7C)
// Ro[gf[^ptO
// bool
#define g_useCVxData (*(bool*)0x6ECE80)
// pbgIuWFNg
// void *
#define g_paletter   (*(void **)0x6E3DF8)
// Cvbg}l[W
// CInputManager ?
#define g_inputMgr   ((void *)0x6E6370)
// Cvbg}l[WNX^
// CInputManagerCluster
#define g_inputMgrs  ((void *)0x6E7520)
// LN^ID
// int
#define g_leftCharID (*(int*)0x6E6FF0)
#define g_rightCharID (*(int*)0x6E7010)
// argc/argv
#define __argc       (*(int*)0x6E7988)
#define __argv       (*(char***)0x6E798C)

// z֐e[u
#define vtbl_CLogo              0x6AC6FC
#define vtbl_Opening            0x6AC798
#define vtbl_CLoading           0x6AC6AC
#define vtbl_CTitle             0x6ACCEC
#define vtbl_CSelect            0x6ACBC4
#define vtbl_CSelectScenario    0x6ACC18
#define vtbl_CBattle            0x6AC470
#define vtbl_Ending             0x6AC5E8
#define vtbl_CSelectSV          0x6AC4AC
#define vtbl_CLoadingSV         0x6AC4CC
#define vtbl_CBattleSV          0x6AC4E8
#define vtbl_CSelectCL          0x6AC504
#define vtbl_CLoadingCL         0x6AC524
#define vtbl_CBattleCL          0x6AC540
#define vtbl_CLoadingWatch      0x6ACE60
#define vtbl_CBattleWatch       0x6AC55C
#define vtbl_CBattleManager     0x6AD50C

// NX\z֐caller
#define CLogo_Creater           0x41D7F7
#define Opening_Creater         0x41D831
#define CLoading_Creater        0x41D86B
#define CTitle_Creater          0x41D8A5
#define CSelect_Creater         0x41D8DF
#define CSelectScenario_Creater 0x41D919
#define CBattle_Creater         0x41D950
#define Ending_Creater          0x41D98A
#define CSelectSV_Creater       0x41D9C4
#define CLoadingSV_Creater      0x41D9FE
#define CBattleSV_Creater       0x41DA35
#define CSelectCL_Creater       0x41DA6F
#define CLoadingCL_Creater      0x41DAA9
#define CBattleCL_Creater       0x41DAE0
#define CLoadingWatch_Creater   0x41DB16
#define CBattleWatch_Creater    0x41DB49
#define CBattleManager_Creater  0x438360

// NXTCYIyh
#define CLogo_Size              (*(DWORD*)0x41D7D5)
#define Opening_Size            (*(DWORD*)0x41D80F)
#define CLoading_Size           (*(DWORD*)0x41D849)
#define CTitle_Size             (*(DWORD*)0x41D883)
#define CSelect_Size            (*(DWORD*)0x41D8BD)
#define CSelectScenario_Size    (*(DWORD*)0x41D8F7)
#define CBattle_Size            (*(BYTE *)0x41D931)
#define Ending_Size             (*(DWORD*)0x41D968)
#define CSelectSV_Size          (*(DWORD*)0x41D9A2)
#define CLoadingSV_Size         (*(DWORD*)0x41D9DC)
#define CBattleSV_Size          (*(BYTE *)0x41DA16)
#define CSelectCL_Size          (*(DWORD*)0x41DA4D)
#define CLoadingCL_Size         (*(DWORD*)0x41DA87)
#define CBattleCL_Size          (*(BYTE *)0x41DAC1)
#define CLoadingWatch_Size      (*(DWORD*)0x41DAF8)
#define CBattleWatch_Size       (*(BYTE *)0x41DB2E)
#define CBattleManager_Size     (*(DWORD*)0x438342)

// ZNVTCY
#define text_Offset  0x401000
#define text_Size    0x2AB000
#define rdata_Offset 0x6AC000
#define rdata_Size   0x24000
#define data_Offset  0x6D0000
#define data_Size    0x1E5A8

// ---------------- ܂Ńev ----------------

// Vertex
struct SWRVERTEX
{
	float x, y, z;
	float rhw;
	D3DCOLOR color;
	float u, v;
};

#define FVF_SWRVERTEX (D3DFVF_XYZRHW | D3DFVF_DIFFUSE | D3DFVF_TEX1)

// POINTfloat
struct POINTF {
	float x, y;
};

// vt@Cjbg
struct DNameUnit {
	SWRFONTDESC fontDesc;
	POINTF position;
	POINTF offset;
	bool backVisible;
};

// po
struct CBattleManager_MyMember {
	bool m_enabled;
	int m_p1TexID;
	int m_p2TexID;
	int m_p1BkTexID;
	int m_p2BkTexID;
};

// og}l[W
#define CBattleManager_Create(p) \
	Ccall(p,s_origCBattleManager_OnCreate,void,())()
#define CBattleManager_Render(p) \
	Ccall(p,s_origCBattleManager_OnRender,bool,())()
#define CBattleManager_Destruct(p, dyn) \
	Ccall(p,s_origCBattleManager_OnDestruct,void*,(int))(dyn)

// IWi CBattleManager 
static DWORD s_origCBattleManager_OnCreate;
static DWORD s_origCBattleManager_OnDestruct;
static DWORD s_origCBattleManager_OnRender;
static DWORD s_origCBattleManager_Size;

// 1P/2P vt@CjbgCX^X
static DNameUnit s_p1Unit;
static DNameUnit s_p2Unit;

// \̉
static bool s_enabledWatch;
static bool s_enabledBattle;

// `v~eBu`
void DrawSprite(int texid, float x, float y, float cx, float cy)
{
	const SWRVERTEX vertices[] = {
		{ x,      y,      0.0f, 1.0f, 0xffffffff, 0.0f, 0.0f },
		{ x + cx, y,      0.0f, 1.0f, 0xffffffff, 1.0f, 0.0f },
		{ x + cx, y + cy, 0.0f, 1.0f, 0xffffffff, 1.0f, 1.0f },
		{ x,      y + cy, 0.0f, 1.0f, 0xffffffff, 0.0f, 1.0f },
	};

	CTextureManager_SetTexture(g_textureMgr, texid, 0);
	g_pd3dDev->DrawPrimitiveUP(D3DPT_TRIANGLEFAN, 2, vertices, sizeof(SWRVERTEX));
}

// vt@Cjbg`
void DrawUnit(const DNameUnit &unit, int bktexid, int texid)
{
	// wi
	if(unit.backVisible) {
		DrawSprite(bktexid, 
			unit.position.x, unit.position.y,
			216.0f, 32.0f);
	}
	// vt@C
	DrawSprite(texid,
		unit.position.x + unit.offset.x,
		unit.position.y + unit.offset.y,
		1024.0f,
		unit.fontDesc.Height + 18.0f);
}

// CBattleWatch RXgN^nh
void * __fastcall CBattleManager_OnCreate(void *This)
{
	CBattleManager_MyMember &my = 
		*(CBattleManager_MyMember*)((char *)This + s_origCBattleManager_Size);
	// super
	CBattleManager_Create(This);
	
	// ϐ킩Mу[hŗLɂ
	my.m_enabled = 
		(s_enabledWatch && g_sceneIdNew == 12) |
		(s_enabledBattle && (g_sceneIdNew == 8 || g_sceneIdNew == 9));

	if(my.m_enabled) {
		char font[0x1A4]; // Ƃ 0x1A4

		// 1P̃vt@CeNX`
		SWRFont_Create(font);
		SWRFont_SetIndirect(font, &s_p1Unit.fontDesc);
		CTextureManager_CreateTextTexture(g_textureMgr,
			&my.m_p1TexID, g_pprofP1, font, 0x400, s_p1Unit.fontDesc.Height + 18);
		SWRFont_Destruct(font);
		// 2P̃vt@CeNX`
		SWRFont_Create(font);
		SWRFont_SetIndirect(font, &s_p2Unit.fontDesc);
		CTextureManager_CreateTextTexture(g_textureMgr,
			&my.m_p2TexID, g_pprofP2, font, 0x400, s_p2Unit.fontDesc.Height + 18);
		SWRFont_Destruct(font);

		// wieNX`
		CTextureManager_LoadTexture(g_textureMgr, &my.m_p1BkTexID,
			"data/scene/select/character/chr_profile1.bmp", NULL, NULL);
		CTextureManager_LoadTexture(g_textureMgr, &my.m_p2BkTexID,
			"data/scene/select/character/chr_profile2.bmp", NULL, NULL);
	}

	return This;
}

// CBattleManager _Onh
// ʑwBegin/End̂łł͕sKv
int __fastcall CBattleManager_OnRender(void *This)
{
	int &m_mode = *(int*)((char *)This + 0x88);
	CBattleManager_MyMember &my = 
		*(CBattleManager_MyMember*)((char *)This + s_origCBattleManager_Size);
	// super
	int ret = CBattleManager_Render(This);

	if(my.m_enabled && m_mode < 5) {
		// CSprite͍RXgȂ̂ŁAߖ
		DrawUnit(s_p1Unit, my.m_p1BkTexID, my.m_p1TexID);
		DrawUnit(s_p2Unit, my.m_p2BkTexID, my.m_p2TexID);
	}
	return ret;
}

// CBattleWatch fXgN^nh
void * __fastcall CBattleManager_OnDestruct(void *This, int, int dyn)
{
	CBattleManager_MyMember &my = 
		*(CBattleManager_MyMember*)((char *)This + s_origCBattleManager_Size);
	if(my.m_enabled) {
		// eNX`j
		CTextureManager_Remove(g_textureMgr, my.m_p1TexID);
		CTextureManager_Remove(g_textureMgr, my.m_p2TexID);
		CTextureManager_Remove(g_textureMgr, my.m_p1BkTexID);
		CTextureManager_Remove(g_textureMgr, my.m_p2BkTexID);
	}
	return CBattleManager_Destruct(This, dyn);
}

// jbgvt@C烍[h
void LoadUnitSettings(DNameUnit &unit, LPCSTR profilePath, LPCSTR sectionName, int defaultX, int defaultY)
{
	// tHg
	::GetPrivateProfileString(sectionName, "Font.Face", 
		(char *)0x69F154, unit.fontDesc.FaceName, _countof(unit.fontDesc.FaceName), profilePath);
	// F
	unit.fontDesc.R1 = ::GetPrivateProfileInt(sectionName, "Font.Color1.R", 255, profilePath);
	unit.fontDesc.R2 = ::GetPrivateProfileInt(sectionName, "Font.Color2.R", 255, profilePath);
	unit.fontDesc.G1 = ::GetPrivateProfileInt(sectionName, "Font.Color1.G", 255, profilePath);
	unit.fontDesc.G2 = ::GetPrivateProfileInt(sectionName, "Font.Color2.G", 255, profilePath);
	unit.fontDesc.B1 = ::GetPrivateProfileInt(sectionName, "Font.Color1.B", 255, profilePath);
	unit.fontDesc.B2 = ::GetPrivateProfileInt(sectionName, "Font.Color2.B", 255, profilePath);
	// tHg
	unit.fontDesc.Height = ::GetPrivateProfileInt(sectionName, "Font.Height", 14, profilePath);
	unit.fontDesc.Weight = ::GetPrivateProfileInt(sectionName, "Font.Bold", 0, profilePath) ? FW_BOLD : FW_NORMAL;
	unit.fontDesc.Italic = ::GetPrivateProfileInt(sectionName, "Font.Italic", 0, profilePath) ? 1 : 0;
	// CȂ
	unit.fontDesc.Shadow = ::GetPrivateProfileInt(sectionName, "Font.Shadow", 1, profilePath) ? 1 : 0;
	unit.fontDesc.BufferSize = 1000000; // unknown buffer size
	unit.fontDesc.CharSpaceX = 0;
	unit.fontDesc.CharSpaceY = 2;
	// \ʒu
	unit.position.x = (float)(int)::GetPrivateProfileInt(sectionName, "Position.X", defaultX, profilePath);
	unit.position.y = (float)(int)::GetPrivateProfileInt(sectionName, "Position.Y", defaultY, profilePath);
	// \ItZbg
	unit.offset.x = (float)(int)::GetPrivateProfileInt(sectionName, "Offset.X", 90, profilePath);
	unit.offset.y = (float)(int)::GetPrivateProfileInt(sectionName, "Offset.Y", 25 - unit.fontDesc.Height, profilePath);
	// wi
	unit.backVisible = ::GetPrivateProfileInt(sectionName, "Back.Visible", 1, profilePath) != 0;
}

// vt@C烍[h
void LoadSettings(LPCSTR profilePath)
{
	LoadUnitSettings(s_p1Unit, profilePath, "1P", 0, 0);
	LoadUnitSettings(s_p2Unit, profilePath, "2P", 424, 0);

	s_enabledWatch  = ::GetPrivateProfileInt("General", "Enabled.Watch", 1, profilePath) != 0;
	s_enabledBattle = ::GetPrivateProfileInt("General", "Enabled.Battle", 1, profilePath) != 0;
}

// tbN
BOOL Hook(HMODULE hModule)
{
	char profilePath[1024 + MAX_PATH];
	// vt@C[h
	GetModuleFileName(hModule, profilePath, 1024);
	PathRemoveFileSpec(profilePath);
	PathAppend(profilePath, "NetProfileView.ini");
	LoadSettings(profilePath);

	// 
	DWORD old;
	::VirtualProtect((PVOID)text_Offset, text_Size, PAGE_EXECUTE_WRITECOPY, &old);
	// CBattleManager ̃TCYg
	s_origCBattleManager_Size = TamperDwordAdd(
		(DWORD)&CBattleManager_Size, sizeof(CBattleManager_MyMember));
	// CBattleManager ctor  call 
	s_origCBattleManager_OnCreate = TamperNearJmpOpr(
		CBattleManager_Creater, union_cast<DWORD>(CBattleManager_OnCreate));
	// 
	TamperNearJmp(0x46D8E2, 0x46D9D6);
	TamperNearJmp(0x46D9E5, 0x46DA50);
	::VirtualProtect((PVOID)text_Offset, text_Size, old, &old);

	::VirtualProtect((PVOID)rdata_Offset, rdata_Size, PAGE_EXECUTE_WRITECOPY, &old);
	// CBattleManager vtbl 
	s_origCBattleManager_OnDestruct = TamperDword(
		vtbl_CBattleManager + 0x00, union_cast<DWORD>(CBattleManager_OnDestruct));
	s_origCBattleManager_OnRender = TamperDword(
		vtbl_CBattleManager + 0x38, union_cast<DWORD>(CBattleManager_OnRender));
	::VirtualProtect((PVOID)rdata_Offset, rdata_Size, old, &old);

	// flush
	::FlushInstructionCache(GetCurrentProcess(), NULL, 0);
	return TRUE;
}

// Gg|Cg
extern "C"
int APIENTRY DllMain(HMODULE hModule, DWORD fdwReason, LPVOID lpReserved)
{
	return (fdwReason == DLL_PROCESS_ATTACH) ? Hook(hModule) : TRUE;
}
