#include <windows.h>
#include <shlwapi.h>

// ---------------- ev ----------------

// DWORD
__inline
DWORD TamperDword(DWORD addr, DWORD target)
{
	DWORD old = *(DWORD*)addr;
	*(DWORD*)addr = target;
	return old;
}

// DWORDZ
__inline
DWORD TamperDwordAdd(DWORD addr, DWORD delta)
{
	DWORD old = *(DWORD*)addr;
	*(DWORD*)addr += delta;
	return old;
}

// NEAR JMPIyh
__inline
DWORD TamperJump(DWORD addr, DWORD target)
{
	DWORD old = *(DWORD*)(addr + 1) + (addr + 5);
	*(DWORD*)(addr + 1) = target - (addr + 5);
	return old;
}

// tHgfBXNv^
#pragma pack(push, 4)
struct SWRFONTDESC {
	char FaceName[0x100];
	BYTE R1;
	BYTE R2;
	BYTE G1;
	BYTE G2;
	BYTE B1;
	BYTE B2;
	LONG Height;
	LONG Weight;
	BYTE Italic;
	BYTE Shadow;
	BYTE UseOffset;
	DWORD BufferSize;
	DWORD OffsetX;
	DWORD OffsetY;
	DWORD CharSpaceX;
	DWORD CharSpaceY;
};

// RpNg
struct SWRSTR {
	union {
		char  str[16];
		char* pstr;
	};
	size_t length;

	operator char *() {
		return length > 15 ? pstr : str;
	}
};

// GtFNg}l[WC^[tF[X
struct IEffectManager {
	virtual void* Destruct(int dynamic) = 0;
	virtual void LoadPattern(LPCSTR fileName, int) = 0;
	virtual void ClearPattern() = 0;
	virtual void AppendRegion(int arg_0, float arg_4, float arg_8, char arg_c, char arg_10, int arg_14) = 0;
	virtual void ClearRegion() = 0;
};

// 悭킩Ȃ
struct UnknownF {
	void *Unknown[3];
	float Aaxis;
	float Baxis;
};

// static_assert
template<bool value>
struct static_assert { typedef struct assert_failed Type; };
template<>
struct static_assert<true> { typedef void* Type; };

// union_cast
template<typename TDest, typename TSrc>
__forceinline 	
TDest union_cast(TSrc src) {
	static_assert<sizeof(TDest) == sizeof(TSrc)>::Type 
		size_mismatch = 0;
	union {  TDest dst; TSrc src; } c;
	c.src = src;
	return c.dst;
}

// thiscall
class C {};
#define Ccall(p,f,r,T) (((C*)p)->*union_cast<r##(C::*)##T>(f))

// tHgIuWFNg\bh
#define SWRFont_Create(p) \
	Ccall(p,0x410E50,void,())()
#define SWRFont_Destruct(p) \
	Ccall(p,0x410EE0,void,())()
#define SWRFont_SetIndirect(p, pdesc) \
	Ccall(p,0x410FC0,void,(void*))(pdesc)

// eNX`}l[W\bh
#define CTextureManager_LoadTexture(p, ret, path, unk1, unk2) \
	Ccall(p,0x4050D0,int*,(int*, LPCSTR, void*, void*))(ret, path, unk1, unk2)
#define CTextureManager_CreateTextTexture(p, ret, str, pdesc ,width ,height) \
	Ccall(p,0x405140,int*,(int*, LPCSTR, void*, int, int))(ret, str, pdesc, width, height)
#define CTextureManager_Remove(p, id) \
	Ccall(p,0x4051B0,void*,(int))(id)
#define CTextureManager_SetTexture(p, id, stage) \
	Ccall(p,0x405230,void,(int, int))(id, stage)
#define CTextureManager_GetSize(p, w, h) \
	Ccall(p,0x4052A0,void,(int*, int*))(w, h)
// eNX`}l[W\bh(nh}l[W̌p)
#define CTextureManager_Get(p, id) \
	((IDirect3DTexture9**)CHandleManager_Get(p, id))
#define CTextureManager_Allocate(p, id) \
	((IDirect3DTexture9**)CHandleManager_Allocate(p, id))
#define CTextureManager_Deallocate(p, id) \
	CHandleManager_Deallocate((void *)p, id)

// nh}l[W\bh
#define CHandleManager_Get(t, p, id) \
	Ccall(p,0x4026C0,t*,(int))(id)
 __declspec(naked) void**
Thunk_CHandleManager_Allocate(void *p, int *ret) {
	// thiscallȂ̂ɗƎvedigĂł@̊
	__asm push edi
	__asm mov edi, [esp+8]
	__asm push [esp+12]
	__asm mov eax, 0x405520
	__asm call eax
	__asm pop edi
	__asm retn
 }
#define CHandleManager_Allocate(p, ret) \
	Thunk_CHandleManager_Allocate(p, ret)
 __declspec(naked) void
Thunk_CHandleManager_Deallocate(void *p, int id) {
	 // thiscall()eaxgĂł@̊
	__asm mov eax, [esp+4]
	__asm push [esp+8]
	__asm mov ecx, 0x402610
	__asm call ecx
	__asm retn
 }
#define CHandleManager_Deallocate(p, id) \
	Thunk_CHandleManager_Deallocate(p, id)

// _\bh
#define CRenderer_Begin(p)  \
	Ccall(p,0x401000,bool,())()
#define CRenderer_End(p) \
	Ccall(p,0x401040,void,())()

// ZNgGtFNg}l[W\bh
#define CSelectEffectManager_Create_Address 0x420FF0
#define CSelectEffectManager_Free_Address   0x422830
#define CSelectEffectManager_Create(p) \
	Ccall(p, CSelectEffectManager_Create_Address, void, ())()

// Cvbg}l[W\bh
#define CInputManager_ReadReplay(p, name) \
	Ccall(p, 0x42BD20, bool,(char *))(name)

// xN^IuWFNg
#define Vector_Create \
	((void (__stdcall *)(void *, size_t, size_t, int, int))0x67B94C)
#define Vector_Destruct \
	((void (__stdcall *)(void *, size_t, size_t, int))0x67B8E9)

// VXeL[Vbg
#define CheckKeyOneshot  \
	((bool(*)(int, int, int, int))0x439CE0)

// pbg[h
#define LoadPackagePalette(pflag, name, pal, bpp) \
	Ccall(pflag, 0x408F00, void, (LPCSTR, void *, int))(name, pal, bpp)

// LN^̎擾
#define GetCharacterAbbr \
	((LPCSTR (__cdecl *)(int id))0x43B080)

// og[hݒ
#define SetBattleMode \
	((void (__cdecl *)(int comm, int sub))0x43AA30)

// eNX`}l[W
// CHandleManager<IDirect3DTexture *>
#define g_textureMgr ((void *)0x6ECD40)
// Direct3DfoCX
// IDirect3DDevice9*
#define g_pd3dDev    (*((IDirect3DDevice9**)0x6ED250))
// _
// CRenderer
#define g_renderer   ((void *)0x6E3DBC)
// lbg[NIuWFNg
// CNetworkServer/CNetworkClient
#define g_pnetObject (*(char**)0x6E62FC)
// vt@C
// char *
#define g_pprofP1 ((char*)(g_pnetObject + 0x04))
#define g_pprofP2 ((char*)(g_pnetObject + 0x24))
// UDPlbg[NIuWFNg
// CNetworkBase
#define g_pnetUdp    (g_pnetObject + 0x3B4)
// sA
// vector<SWRClientInfo> ?
#define g_psvClients (g_pnetUdp + 0xFC)
// T[oAhX
// in_addr
#define g_ptoAddr    (g_pnetUdp + 0x2C)
// og}l[W
// CBattleManager *
#define g_pbattleMgr (*(void **)0x6E6244)
// CtH}l[W
// CInfoManager *
#define g_pinfoMgr   (*(void **)0x6E6248)
// [h
// int
#define g_commMode   (*(DWORD*)0x6E62EC)
#define g_subMode    (*(DWORD*)0x6E62E4)
#define g_menuMode   (*(DWORD*)0x6D094C)
// V[ID
// DWORD
#define g_sceneIdNew (*(DWORD*)0x6ECE78)
#define g_sceneId    (*(DWORD*)0x6ECE7C)
// Ro[gf[^ptO
// bool
#define g_useCVxData (*(bool*)0x6ECE80)
// pbgIuWFNg
// void *
#define g_paletter   (*(void **)0x6E3DF8)
// Cvbg}l[W
// CInputManager ?
#define g_inputMgr   ((void *)0x6E6370)
// Cvbg}l[WNX^
// CInputManagerCluster
#define g_inputMgrs  ((void *)0x6E7520)
// LN^ID
// int
#define g_leftCharID (*(int*)0x6E6FF0)
#define g_rightCharID (*(int*)0x6E7010)
// argc/argv
#define __argc       (*(int*)0x6E7988)
#define __argv       (*(char***)0x6E798C)

// z֐e[u
#define vtbl_CLogo              0x6AC6FC
#define vtbl_Opening            0x6AC798
#define vtbl_CLoading           0x6AC6AC
#define vtbl_CTitle             0x6ACCEC
#define vtbl_CSelect            0x6ACBC4
#define vtbl_CSelectScenario    0x6ACC18
#define vtbl_CBattle            0x6AC470
#define vtbl_Ending             0x6AC5E8
#define vtbl_CSelectSV          0x6AC4AC
#define vtbl_CLoadingSV         0x6AC4CC
#define vtbl_CBattleSV          0x6AC4E8
#define vtbl_CSelectCL          0x6AC504
#define vtbl_CLoadingCL         0x6AC524
#define vtbl_CBattleCL          0x6AC540
#define vtbl_CLoadingWatch      0x6ACE60
#define vtbl_CBattleWatch       0x6AC55C

// NX\z֐caller
#define CLogo_Creater           0x41D7F7
#define Opening_Creater         0x41D831
#define CLoading_Creater        0x41D86B
#define CTitle_Creater          0x41D8A5
#define CSelect_Creater         0x41D8DF
#define CSelectScenario_Creater 0x41D919
#define CBattle_Creater         0x41D950
#define Ending_Creater          0x41D98A
#define CSelectSV_Creater       0x41D9C4
#define CLoadingSV_Creater      0x41D9FE
#define CBattleSV_Creater       0x41DA35
#define CSelectCL_Creater       0x41DA6F
#define CLoadingCL_Creater      0x41DAA9
#define CBattleCL_Creater       0x41DAE0
#define CLoadingWatch_Creater   0x41DB16
#define CBattleWatch_Creater    0x41DB49

// NXTCYIyh
#define CLogo_Size              (*(DWORD*)0x41D7D5)
#define Opening_Size            (*(DWORD*)0x41D80F)
#define CLoading_Size           (*(DWORD*)0x41D849)
#define CTitle_Size             (*(DWORD*)0x41D883)
#define CSelect_Size            (*(DWORD*)0x41D8BD)
#define CSelectScenario_Size    (*(DWORD*)0x41D8F7)
#define CBattle_Size            (*(BYTE *)0x41D931)
#define Ending_Size             (*(DWORD*)0x41D968)
#define CSelectSV_Size          (*(DWORD*)0x41D9A2)
#define CLoadingSV_Size         (*(DWORD*)0x41D9DC)
#define CBattleSV_Size          (*(BYTE *)0x41DA16)
#define CSelectCL_Size          (*(DWORD*)0x41DA4D)
#define CLoadingCL_Size         (*(DWORD*)0x41DA87)
#define CBattleCL_Size          (*(BYTE *)0x41DAC1)
#define CLoadingWatch_Size      (*(DWORD*)0x41DAF8)
#define CBattleWatch_Create     (*(BYTE *)0x41DB2E)

// ZNVTCY
#define text_Offset  0x401000
#define text_Size    0x2AB000
#define rdata_Offset 0x6AC000
#define rdata_Size   0x24000
#define data_Offset  0x6D0000
#define data_Size    0x1E5A8

// ---------------- ܂Ńev ----------------


#define CLogo_Process(p)   \
	Ccall(p, s_origCLogo_OnProcess, int, ())()
#define CBattle_Process(p) \
	Ccall(p, s_origCBattle_OnProcess, int, ())()

#define SWRCHAR_MAX 15

static DWORD s_origCLogo_OnProcess;
static DWORD s_origCBattle_OnProcess;

static bool s_swrapt;
static bool s_autoShutdown;

int __fastcall CLogo_OnProcess(void *This)
{
	int ret = CLogo_Process(This);
	if(ret == 1 && __argc == 2) {
		if(CInputManager_ReadReplay(g_inputMgr, __argv[1])) {
			s_swrapt = true;
			// ͂悤ɌBEND
			*(BYTE*)((DWORD)g_inputMgrs + 0x74) = 0xFF;
			// v[hɃ`FW
			SetBattleMode(3, 2);
			ret = 6;
		}
	}
	return ret;
}

int __fastcall CBattle_OnProcess(void *This)
{
	int ret = CBattle_Process(This);
	if(s_swrapt && ret == 2) {
		s_swrapt = false;
		if(s_autoShutdown) {
			// Ƃ
			ret = -1;
		}
	}
	return ret;
}

// ݒ胍[h
void LoadSettings(LPCSTR profilePath)
{
	// Vbg_E
	s_autoShutdown = GetPrivateProfileInt("ReplayDnD", "AutoShutdown", 1, profilePath) != 0;
}

// tbN
BOOL Hook(HMODULE hModule)
{
	char profilePath[1024 + MAX_PATH];

	GetModuleFileName(hModule, profilePath, 1024);
	PathRemoveFileSpec(profilePath);
	PathAppend(profilePath, "ReplayDnD.ini");
	LoadSettings(profilePath);

	DWORD old;
	::VirtualProtect((PVOID)rdata_Offset, rdata_Size, PAGE_EXECUTE_WRITECOPY, &old);
	s_origCLogo_OnProcess   = TamperDword(vtbl_CLogo   + 4, (DWORD)CLogo_OnProcess);
	s_origCBattle_OnProcess = TamperDword(vtbl_CBattle + 4, (DWORD)CBattle_OnProcess);
	::VirtualProtect((PVOID)rdata_Offset, rdata_Size, old, &old);

	::FlushInstructionCache(GetCurrentProcess(), NULL, 0);

	return TRUE;
}

extern "C"
int APIENTRY DllMain(HMODULE hModule, DWORD fdwReason, LPVOID lpReserved)
{
	return (fdwReason == DLL_PROCESS_ATTACH) ? Hook(hModule) : TRUE;
}

