#include <windows.h>
#include <shlwapi.h>
#include <d3d9.h>
#include <d3dx9.h>
#include <dinput.h>

#include "resource.h"

// ---------------- ev ----------------

// DWORD
__inline
DWORD TamperDword(DWORD addr, DWORD target)
{
	DWORD old = *(DWORD*)addr;
	*(DWORD*)addr = target;
	return old;
}

// DWORDZ
__inline
DWORD TamperDwordAdd(DWORD addr, DWORD delta)
{
	DWORD old = *(DWORD*)addr;
	*(DWORD*)addr += delta;
	return old;
}

// NEAR JMPIyh
__inline
DWORD TamperJump(DWORD addr, DWORD target)
{
	DWORD old = *(DWORD*)(addr + 1) + (addr + 5);
	*(DWORD*)(addr + 1) = target - (addr + 5);
	return old;
}

// tHgfBXNv^
#pragma pack(push, 4)
struct SWRFONTDESC {
	char FaceName[0x100];
	BYTE R1;
	BYTE R2;
	BYTE G1;
	BYTE G2;
	BYTE B1;
	BYTE B2;
	LONG Height;
	LONG Weight;
	BYTE Italic;
	BYTE Shadow;
	BYTE UseOffset;
	DWORD BufferSize;
	DWORD OffsetX;
	DWORD OffsetY;
	DWORD CharSpaceX;
	DWORD CharSpaceY;
};

// RpNg
struct SWRSTR {
	union {
		char  str[16];
		char* pstr;
	};
	size_t length;

	operator char *() {
		return length > 15 ? pstr : str;
	}
};

// GtFNg}l[WC^[tF[X
struct IEffectManager {
	virtual void* Destruct(int dynamic) = 0;
	virtual void LoadPattern(LPCSTR fileName, int) = 0;
	virtual void ClearPattern() = 0;
	virtual void AppendRegion(int arg_0, float arg_4, float arg_8, char arg_c, char arg_10, int arg_14) = 0;
	virtual void ClearRegion() = 0;
};

// 悭킩Ȃ
struct UnknownF {
	void *Unknown[3];
	float Aaxis;
	float Baxis;
};

// static_assert
template<bool value>
struct static_assert { typedef struct assert_failed Type; };
template<>
struct static_assert<true> { typedef void* Type; };

// union_cast
template<typename TDest, typename TSrc>
__forceinline 	
TDest union_cast(TSrc src) {
	static_assert<sizeof(TDest) == sizeof(TSrc)>::Type 
		size_mismatch = 0;
	union {  TDest dst; TSrc src; } c;
	c.src = src;
	return c.dst;
}

// thiscall
class C {};
#define Ccall(p,f,r,T) (((C*)p)->*union_cast<r##(C::*)##T>(f))

// tHgIuWFNg\bh
#define SWRFont_Create(p) \
	Ccall(p,0x410E50,void,())()
#define SWRFont_Destruct(p) \
	Ccall(p,0x410EE0,void,())()
#define SWRFont_SetIndirect(p, pdesc) \
	Ccall(p,0x410FC0,void,(void*))(pdesc)

// eNX`}l[W\bh
#define CTextureManager_LoadTexture(p, ret, path, unk1, unk2) \
	Ccall(p,0x4050D0,int*,(int*, LPCSTR, void*, void*))(ret, path, unk1, unk2)
#define CTextureManager_CreateTextTexture(p, ret, str, pdesc ,width ,height) \
	Ccall(p,0x405140,int*,(int*, LPCSTR, void*, int, int))(ret, str, pdesc, width, height)
#define CTextureManager_Remove(p, id) \
	Ccall(p,0x4051B0,void*,(int))(id)
#define CTextureManager_SetTexture(p, id, stage) \
	Ccall(p,0x405230,void,(int, int))(id, stage)
#define CTextureManager_GetSize(p, w, h) \
	Ccall(p,0x4052A0,void,(int*, int*))(w, h)
// eNX`}l[W\bh(nh}l[W̌p)
#define CTextureManager_Get(p, id) \
	((IDirect3DTexture9**)CHandleManager_Get(p, id))
#define CTextureManager_Allocate(p, id) \
	((IDirect3DTexture9**)CHandleManager_Allocate(p, id))
#define CTextureManager_Deallocate(p, id) \
	CHandleManager_Deallocate((void *)p, id)

// nh}l[W\bh
#define CHandleManager_Get(t, p, id) \
	Ccall(p,0x4026C0,t*,(int))(id)
 __declspec(naked) void**
Thunk_CHandleManager_Allocate(void *p, int *ret) {
	// thiscallȂ̂ɗƎvedigĂł@̊
	__asm push edi
	__asm mov edi, [esp+8]
	__asm push [esp+12]
	__asm mov eax, 0x405520
	__asm call eax
	__asm pop edi
	__asm retn
 }
#define CHandleManager_Allocate(p, ret) \
	Thunk_CHandleManager_Allocate(p, ret)
 __declspec(naked) void
Thunk_CHandleManager_Deallocate(void *p, int id) {
	 // thiscall()eaxgĂł@̊
	__asm mov eax, [esp+4]
	__asm push [esp+8]
	__asm mov ecx, 0x402610
	__asm call ecx
	__asm retn
 }
#define CHandleManager_Deallocate(p, id) \
	Thunk_CHandleManager_Deallocate(p, id)

// _\bh
#define CRenderer_Begin(p)  \
	Ccall(p,0x401000,bool,())()
#define CRenderer_End(p) \
	Ccall(p,0x401040,void,())()

// ZNgGtFNg}l[W\bh
#define CSelectEffectManager_Create_Address 0x420FF0
#define CSelectEffectManager_Free_Address   0x422830
#define CSelectEffectManager_Create(p) \
	Ccall(p, CSelectEffectManager_Create_Address, void, ())()

// Cvbg}l[W\bh
#define CInputManager_ReadReplay(p, name) \
	Ccall(p, 0x42BD20, bool,(char *))(name)

// xN^IuWFNg
#define Vector_Create \
	((void (__stdcall *)(void *, size_t, size_t, int, int))0x67B94C)
#define Vector_Destruct \
	((void (__stdcall *)(void *, size_t, size_t, int))0x67B8E9)

// VXeL[Vbg
#define CheckKeyOneshot  \
	((bool(*)(int, int, int, int))0x439CE0)

// pbg[h
#define LoadPackagePalette(pflag, name, pal, bpp) \
	Ccall(pflag, 0x408F00, void, (LPCSTR, void *, int))(name, pal, bpp)

// LN^̎擾
#define GetCharacterAbbr \
	((LPCSTR (__cdecl *)(int id))0x43B080)

// og[hݒ
#define SetBattleMode \
	((void (__cdecl *)(int comm, int sub))0x43AA30)

// eNX`}l[W
// CHandleManager<IDirect3DTexture *>
#define g_textureMgr ((void *)0x6ECD40)
// Direct3DfoCX
// IDirect3DDevice9*
#define g_pd3dDev    (*((IDirect3DDevice9**)0x6ED250))
// _
// CRenderer
#define g_renderer   ((void *)0x6E3DBC)
// lbg[NIuWFNg
// CNetworkServer/CNetworkClient
#define g_pnetObject (*(char**)0x6E62FC)
// vt@C
// char *
#define g_pprofP1 ((char*)(g_pnetObject + 0x04))
#define g_pprofP2 ((char*)(g_pnetObject + 0x24))
// UDPlbg[NIuWFNg
// CNetworkBase
#define g_pnetUdp    (g_pnetObject + 0x3B4)
// sA
// vector<SWRClientInfo> ?
#define g_psvClients (g_pnetUdp + 0xFC)
// T[oAhX
// in_addr
#define g_ptoAddr    (g_pnetUdp + 0x2C)
// og}l[W
// CBattleManager *
#define g_pbattleMgr (*(void **)0x6E6244)
// CtH}l[W
// CInfoManager *
#define g_pinfoMgr   (*(void **)0x6E6248)
// [h
// int
#define g_commMode   (*(DWORD*)0x6E62EC)
#define g_subMode    (*(DWORD*)0x6E62E4)
#define g_menuMode   (*(DWORD*)0x6D094C)
// V[ID
// DWORD
#define g_sceneIdNew (*(DWORD*)0x6ECE78)
#define g_sceneId    (*(DWORD*)0x6ECE7C)
// Ro[gf[^ptO
// bool
#define g_useCVxData (*(bool*)0x6ECE80)
// pbgIuWFNg
// void *
#define g_paletter   (*(void **)0x6E3DF8)
// Cvbg}l[W
// CInputManager ?
#define g_inputMgr   ((void *)0x6E6370)
// Cvbg}l[WNX^
// CInputManagerCluster
#define g_inputMgrs  ((void *)0x6E7520)
// LN^ID
// int
#define g_leftCharID (*(int*)0x6E6FF0)
#define g_rightCharID (*(int*)0x6E7010)
// argc/argv
#define __argc       (*(int*)0x6E7988)
#define __argv       (*(char***)0x6E798C)

// z֐e[u
#define vtbl_CLogo              0x6AC6FC
#define vtbl_Opening            0x6AC798
#define vtbl_CLoading           0x6AC6AC
#define vtbl_CTitle             0x6ACCEC
#define vtbl_CSelect            0x6ACBC4
#define vtbl_CSelectScenario    0x6ACC18
#define vtbl_CBattle            0x6AC470
#define vtbl_Ending             0x6AC5E8
#define vtbl_CSelectSV          0x6AC4AC
#define vtbl_CLoadingSV         0x6AC4CC
#define vtbl_CBattleSV          0x6AC4E8
#define vtbl_CSelectCL          0x6AC504
#define vtbl_CLoadingCL         0x6AC524
#define vtbl_CBattleCL          0x6AC540
#define vtbl_CLoadingWatch      0x6ACE60
#define vtbl_CBattleWatch       0x6AC55C
#define vtbl_CBattleManager     0x6AD50C

// NX\z֐caller
#define CLogo_Creater           0x41D7F7
#define Opening_Creater         0x41D831
#define CLoading_Creater        0x41D86B
#define CTitle_Creater          0x41D8A5
#define CSelect_Creater         0x41D8DF
#define CSelectScenario_Creater 0x41D919
#define CBattle_Creater         0x41D950
#define Ending_Creater          0x41D98A
#define CSelectSV_Creater       0x41D9C4
#define CLoadingSV_Creater      0x41D9FE
#define CBattleSV_Creater       0x41DA35
#define CSelectCL_Creater       0x41DA6F
#define CLoadingCL_Creater      0x41DAA9
#define CBattleCL_Creater       0x41DAE0
#define CLoadingWatch_Creater   0x41DB16
#define CBattleWatch_Creater    0x41DB49
#define CBattleManager_Creater  0x438360

// NXTCYIyh
#define CLogo_Size              (*(DWORD*)0x41D7D5)
#define Opening_Size            (*(DWORD*)0x41D80F)
#define CLoading_Size           (*(DWORD*)0x41D849)
#define CTitle_Size             (*(DWORD*)0x41D883)
#define CSelect_Size            (*(DWORD*)0x41D8BD)
#define CSelectScenario_Size    (*(DWORD*)0x41D8F7)
#define CBattle_Size            (*(BYTE *)0x41D931)
#define Ending_Size             (*(DWORD*)0x41D968)
#define CSelectSV_Size          (*(DWORD*)0x41D9A2)
#define CLoadingSV_Size         (*(DWORD*)0x41D9DC)
#define CBattleSV_Size          (*(BYTE *)0x41DA16)
#define CSelectCL_Size          (*(DWORD*)0x41DA4D)
#define CLoadingCL_Size         (*(DWORD*)0x41DA87)
#define CBattleCL_Size          (*(BYTE *)0x41DAC1)
#define CLoadingWatch_Size      (*(DWORD*)0x41DAF8)
#define CBattleWatch_Size       (*(BYTE *)0x41DB2E)
#define CBattleManager_Size     (*(DWORD*)0x438342)

// ZNVTCY
#define text_Offset  0x401000
#define text_Size    0x2AB000
#define rdata_Offset 0x6AC000
#define rdata_Size   0x24000
#define data_Offset  0x6D0000
#define data_Size    0x1E5A8

// ---------------- ܂Ńev ----------------


struct SWRCHARINPUT
{
	int lr;
	int ud;
	int a;
	int b;
	int c;
	int d;
	int ch;
	int s;
};

struct SWRVERTEX
{
	float x, y, z;
	float rhw;
	D3DCOLOR color;
	float u, v;
};

struct SWRCMDINFO
{
	int prev;
	int now;

	struct {
		bool enabled;
		int id[10];
		int base;
		int len;
	} record;
};

struct MYMEMBER {
	int m_texID;
	SWRCMDINFO m_cmdp1;
	SWRCMDINFO m_cmdp2;
};

#define FVF_SWRVERTEX (D3DFVF_XYZRHW | D3DFVF_DIFFUSE | D3DFVF_TEX1)

HRESULT (__stdcall *s_D3DXCreateTextureFromResource)(
    LPDIRECT3DDEVICE9 pDevice,
    HMODULE hSrcModule,
    LPCTSTR pSrcResource,
    LPDIRECT3DTEXTURE9 *ppTexture
);

// og}l[W
#define CBattleManager_Create(p) \
	Ccall(p, s_origCBattleManager_OnCreate, void*, ())()
#define CBattleManager_Render(p) \
	Ccall(p, s_origCBattleManager_OnRender, void, ())()
#define CBattleManager_Process(p) \
	Ccall(p, s_origCBattleManager_OnProcess, int, ())()
#define CBattleManager_Destruct(p, dyn) \
	Ccall(p, s_origCBattleManager_OnDestruct, void*, (int))(dyn)
// ogV[
#define CBattle_Process(p) \
	Ccall(p, s_origCBattle_OnProcess, int, ())()
#define CBattle_Destruct(p, dyn) \
	Ccall(p, s_origCBattle_OnDestruct, void*, (int))(dyn)

static DWORD s_origCBattleManager_OnCreate;
static DWORD s_origCBattleManager_OnDestruct;
static DWORD s_origCBattleManager_OnRender;
static DWORD s_origCBattleManager_OnProcess;
static DWORD s_origCBattleManager_Size;

static DWORD s_origCBattle_OnDestruct;
static DWORD s_origCBattle_OnProcess;

static bool s_enabled;
static HMODULE s_hDllModule;

static int s_forwardCount = 1;
static int s_forwardStep  = 1;
static int s_forwardIndex = 0;

#ifndef _DEBUG
extern "C"
int _fltused = 1;
#endif

int * CTextureManager_LoadTextureFromResource(void *ptextureMgr, int *ret, HMODULE hSrcModule, LPCTSTR pSrcResource)
{
	int id = 0;
	LPDIRECT3DTEXTURE9 *pphandle = CTextureManager_Allocate(ptextureMgr, &id);

	*pphandle = NULL;
	if(SUCCEEDED(s_D3DXCreateTextureFromResource(g_pd3dDev, hSrcModule, pSrcResource, pphandle))) {
		*ret = id;
	} else {
		CTextureManager_Deallocate(ptextureMgr, id);
		*ret = 0;
	}
	return ret;
}

void __fastcall CBattleManager_RenderMyBack(float x, float y, int cx, int cy)
{
	const SWRVERTEX vertices[] = {
		{ x,          y,      0.0f, 1.0f, 0xa0808080, 0.0f, 0.0f },
		{ x + cx + 0, y,      0.0f, 1.0f, 0xa0808080, 1.0f, 0.0f },
		{ x + cx + 5, y + cy, 0.0f, 1.0f, 0xa0202020, 1.0f, 1.0f },
		{ x      + 5, y + cy, 0.0f, 1.0f, 0xa0202020, 0.0f, 1.0f },
	};
	CTextureManager_SetTexture(g_textureMgr, NULL, 0);
	g_pd3dDev->DrawPrimitiveUP(D3DPT_TRIANGLEFAN, 2, vertices, sizeof(SWRVERTEX));
}


void CBattleManager_RenderTile(float x, float y, int u, int v, int a)
{
	int dif = (a << 24) | 0xFFFFFF;
	float fu = u / 256.0f;
	float fv = v / 64.0f;

	// fobOrhƃO_O_ɂȂ͉̂Ȃ́Hʂ́H
	const SWRVERTEX vertices[] = {
		{ x,         y,         0.0f, 1.0f, dif, fu,          fv },
		{ x + 32.0f, y,         0.0f, 1.0f, dif, fu + 0.125f, fv },
		{ x + 32.0f, y + 32.0f, 0.0f, 1.0f, dif, fu + 0.125f, fv + 0.5f },
		{ x,         y + 32.0f, 0.0f, 1.0f, dif, fu,          fv + 0.5f },
	};
	g_pd3dDev->DrawPrimitiveUP(D3DPT_TRIANGLEFAN, 2, vertices, sizeof(SWRVERTEX));
}

void CBattleManager_RenderInputPanel(void *This, SWRCMDINFO &cmd, float x, float y)
{
	MYMEMBER &my = *(MYMEMBER *)((char *)g_pbattleMgr + s_origCBattleManager_Size);

	// 
	CBattleManager_RenderMyBack(x, y, 24 * 6 + 24, 24 * 3 + 12);

	CTextureManager_SetTexture(g_textureMgr, my.m_texID, 0);

	// WCXeBbN
	CBattleManager_RenderTile(x + 9,      y + 6,      128, 0, (cmd.now % 16 == 5 ? 255: 48)); /* LU */
	CBattleManager_RenderTile(x + 9 + 24, y + 6,        0, 0, (cmd.now % 16 == 1 ? 255: 48)); /* NU */
	CBattleManager_RenderTile(x + 9 + 48, y + 6,      160, 0, (cmd.now % 16 == 9 ? 255: 48)); /* RU */
	CBattleManager_RenderTile(x + 9,      y + 6 + 24,  64, 0, (cmd.now % 16 == 4 ? 255: 48)); /* LN */
	CBattleManager_RenderTile(x + 9 + 48, y + 6 + 24,  96, 0, (cmd.now % 16 == 8 ? 255: 48)); /* RN */
	CBattleManager_RenderTile(x + 9,      y + 6 + 48, 224, 0, (cmd.now % 16 == 6 ? 255: 48)); /* LD */
	CBattleManager_RenderTile(x + 9 + 24, y + 6 + 48,  32, 0, (cmd.now % 16 == 2 ? 255: 48)); /* ND */
	CBattleManager_RenderTile(x + 9 + 48, y + 6 + 48, 192, 0, (cmd.now % 16 ==10 ? 255: 48)); /* RD */
	// {^
	CBattleManager_RenderTile(x + 9 + 72 + 3,      y + 6 + 12,   0, 32, (cmd.now & 16  ? 255: 48));
	CBattleManager_RenderTile(x + 9 + 72 + 3 + 27, y + 6 + 12,  32, 32, (cmd.now & 32  ? 255: 48));
	CBattleManager_RenderTile(x + 9 + 72 + 3 + 54, y + 6 + 12,  64, 32, (cmd.now & 64  ? 255: 48));
	CBattleManager_RenderTile(x + 9 + 72 + 6,      y + 6 + 36,  96, 32, (cmd.now & 128 ? 255: 48));
	CBattleManager_RenderTile(x + 9 + 72 + 6 + 27, y + 6 + 36, 128, 32, (cmd.now & 256 ? 255: 48));
	CBattleManager_RenderTile(x + 9 + 72 + 6 + 54, y + 6 + 36, 160, 32, (cmd.now & 512 ? 255: 48)); 

}

void CBattleManager_RenderRecordPanel(void *This, SWRCMDINFO &cmd, float x, float y)
{
	MYMEMBER &my = *(MYMEMBER *)((char *)This + s_origCBattleManager_Size);

	if(cmd.record.enabled) {
		// 
		CBattleManager_RenderMyBack(x, y, 24 * 10 + 6, 24 + 6);

		CTextureManager_SetTexture(g_textureMgr, my.m_texID, 0);
		for(int i = 0; i < cmd.record.len; ++i) {
			int j = (i + cmd.record.base) % _countof(cmd.record.id);
			int id = cmd.record.id[j];
			CBattleManager_RenderTile(x + 3 + i * 24, y + 3, (id % 8) * 32, (id / 8) * 32, 255);
		}
	}
}

void CBattleManager_DetermineRecord(SWRCMDINFO &cmd, int mask, int flag, int id)
{
	if((cmd.prev & mask) != flag && (cmd.now & mask) == flag) {
		int index = (cmd.record.base + cmd.record.len) % _countof(cmd.record.id);
		cmd.record.id[index] = id;
		if(cmd.record.len == _countof(cmd.record.id)) {
			cmd.record.base = (cmd.record.base + 1) % _countof(cmd.record.id);
		} else {
			cmd.record.len++;
		}
	}
}

void CBattleManager_RefleshCommandInfo(SWRCMDINFO &cmd, void *Char)
{
	SWRCHARINPUT &input = *(SWRCHARINPUT*)((char*)Char + 0x6B4);

	cmd.prev = cmd.now;
	cmd.now = 0;
	if(input.ud < 0) cmd.now |= 1;
	if(input.ud > 0) cmd.now |= 2;
	if(input.lr < 0) cmd.now |= 4;
	if(input.lr > 0) cmd.now |= 8;
	if(input.a > 0)
		cmd.now |= 16;
	if(input.b > 0)  cmd.now |= 32;
	if(input.c > 0)  cmd.now |= 64;
	if(input.d > 0)  cmd.now |= 128;
	if(input.ch> 0)  cmd.now |= 256;
	if(input.s > 0)  cmd.now |= 512;

	if(cmd.record.enabled) {
		CBattleManager_DetermineRecord(cmd, 15, 5, 4);
		CBattleManager_DetermineRecord(cmd, 15, 1, 0);
		CBattleManager_DetermineRecord(cmd, 15, 9, 5);
		CBattleManager_DetermineRecord(cmd, 15, 4, 2);
		CBattleManager_DetermineRecord(cmd, 15, 8, 3);
		CBattleManager_DetermineRecord(cmd, 15, 6, 7);
		CBattleManager_DetermineRecord(cmd, 15, 2, 1);
		CBattleManager_DetermineRecord(cmd, 15,10, 6);

		CBattleManager_DetermineRecord(cmd, 16, 16, 8);
		CBattleManager_DetermineRecord(cmd, 32, 32, 9);
		CBattleManager_DetermineRecord(cmd, 64, 64, 10);
		CBattleManager_DetermineRecord(cmd, 128, 128, 11);
		CBattleManager_DetermineRecord(cmd, 256, 256, 12);
		CBattleManager_DetermineRecord(cmd, 512, 512, 13);
	}
}

void * __fastcall CBattleManager_OnCreate(void *This)
{
	MYMEMBER &my = *(MYMEMBER *)((char *)This + s_origCBattleManager_Size);

	// super
	CBattleManager_Create(This);

	if(g_subMode == 2 && g_commMode == 3) {
		// Replay
		s_enabled = true;
	} else {
		// ȊO
		s_enabled = false;
	}

	if(s_enabled) {
		CTextureManager_LoadTextureFromResource(
			g_textureMgr, &my.m_texID, s_hDllModule, MAKEINTRESOURCE(IDR_RCIMAGE));
		if(my.m_texID != 0) {
			my.m_cmdp1.prev = 0;
			my.m_cmdp1.record.base = my.m_cmdp1.record.len = 0;
			my.m_cmdp1.record.enabled = false;

			my.m_cmdp2.prev = 0;
			my.m_cmdp2.record.base = my.m_cmdp2.record.len = 0;
			my.m_cmdp2.record.enabled = false;
		} else {
			// ς߂
			s_enabled = false;
		}
	}
	return This;
}

int __fastcall CBattleManager_OnProcess(void *This)
{
	MYMEMBER &my = *(MYMEMBER *)((char *)This + s_origCBattleManager_Size);

	int ret = CBattleManager_Process(This);

	if(s_enabled) {
		void *p1Obj = *(void**)((char *)This + 0xC);
		void *p2Obj = *(void**)((char *)This + 0x10);
		CBattleManager_RefleshCommandInfo(my.m_cmdp1, p1Obj);
		CBattleManager_RefleshCommandInfo(my.m_cmdp2, p2Obj);
	}

	return ret;
}

void __fastcall CBattleManager_OnRender(void *This)
{
	MYMEMBER &my = *(MYMEMBER *)((char *)This + s_origCBattleManager_Size);

	CBattleManager_Render(This);

	if(s_enabled) {
		CBattleManager_RenderInputPanel(This, my.m_cmdp1,  60, 340);
		CBattleManager_RenderInputPanel(This, my.m_cmdp2, 400, 340);
		CBattleManager_RenderRecordPanel(This, my.m_cmdp1,   0, 300);
		CBattleManager_RenderRecordPanel(This, my.m_cmdp2, 390, 300);
	}
}

void * __fastcall CBattleManager_OnDestruct(void *This, int, int dyn)
{
	MYMEMBER &my = *(MYMEMBER *)((char *)This + s_origCBattleManager_Size);

	if(s_enabled) {
		CTextureManager_Remove(g_textureMgr, my.m_texID);
	}

	return CBattleManager_Destruct(This, dyn);
}

int __fastcall CBattle_OnProcess(void *This)
{
	MYMEMBER &my = *(MYMEMBER *)((char *)g_pbattleMgr + s_origCBattleManager_Size);

	if(s_enabled) {
		if(CheckKeyOneshot(DIK_F8, 0, 0, 0) && g_pbattleMgr) {	
			my.m_cmdp1.record.enabled = !my.m_cmdp1.record.enabled;
		} else if(CheckKeyOneshot(DIK_F9, 0, 0, 0) && g_pbattleMgr) {
			my.m_cmdp2.record.enabled = !my.m_cmdp2.record.enabled;
		} else if(CheckKeyOneshot(DIK_F10, 0, 0, 0)) {
			if(s_forwardCount > 1) {
				s_forwardCount -= 1;
				s_forwardStep   = 1;
			} else {
				s_forwardCount  = 1;
				s_forwardStep  += 1;
			}
			s_forwardIndex  = 0;
		} else if(CheckKeyOneshot(DIK_F11, 0, 0, 0)) {
			if(s_forwardStep > 1) {
				s_forwardCount  = 1;
				s_forwardStep  -= 1;
			} else {
				s_forwardCount += 1;
				s_forwardStep   = 1;
			}
			s_forwardIndex  = 0;
		} else if(CheckKeyOneshot(DIK_F12, 0, 0, 0)) {
			s_forwardCount  = 1;
			s_forwardStep   = 1;
			s_forwardIndex  = 0;
		}

		int ret = 5 ; /* battle */
		s_forwardIndex += s_forwardStep;
		if(s_forwardIndex >= s_forwardCount) {
			for(int i = s_forwardIndex / s_forwardCount; i--;)
				ret = CBattle_Process(This);
			s_forwardIndex = 0;
		}
		return ret;
	} else {
		return CBattle_Process(This);
	}
}

void * __fastcall CBattle_OnDestruct(void *This, int, int dyn)
{
	s_forwardCount = 1;
	s_forwardStep  = 1;
	s_forwardIndex = 0;
	return CBattle_Destruct(This, dyn);
}

BOOL Hook(HMODULE hModule)
{
	s_hDllModule = hModule;

	HMODULE d3dx = LoadLibrary("D3DX9_33.DLL");
	if(d3dx == NULL) return FALSE;
	*(FARPROC*)&s_D3DXCreateTextureFromResource =
		GetProcAddress(d3dx, "D3DXCreateTextureFromResourceA");
	if(s_D3DXCreateTextureFromResource == NULL) return FALSE;
	
	DWORD old;
	::VirtualProtect((PVOID)text_Offset, text_Size, PAGE_EXECUTE_WRITECOPY, &old);
	s_origCBattleManager_Size = 
		TamperDwordAdd((DWORD)&CBattleManager_Size, sizeof(MYMEMBER));
	s_origCBattleManager_OnCreate = 
		TamperJump(CBattleManager_Creater, union_cast<DWORD>(CBattleManager_OnCreate));
	::VirtualProtect((PVOID)text_Offset, text_Size, old, &old);

	::VirtualProtect((PVOID)rdata_Offset, rdata_Size, PAGE_EXECUTE_WRITECOPY, &old);
	s_origCBattle_OnDestruct =
		TamperDword(vtbl_CBattle + 0, union_cast<DWORD>(CBattle_OnDestruct));
	s_origCBattle_OnProcess =
		TamperDword(vtbl_CBattle + 4, union_cast<DWORD>(CBattle_OnProcess));

	s_origCBattleManager_OnDestruct = 
		TamperDword(vtbl_CBattleManager + 0x00, union_cast<DWORD>(CBattleManager_OnDestruct));
	s_origCBattleManager_OnRender = 
		TamperDword(vtbl_CBattleManager + 0x38, union_cast<DWORD>(CBattleManager_OnRender));
	s_origCBattleManager_OnProcess =
		TamperDword(vtbl_CBattleManager + 0x0c, union_cast<DWORD>(CBattleManager_OnProcess));
	::VirtualProtect((PVOID)rdata_Offset, rdata_Size, old, &old);

	::FlushInstructionCache(GetCurrentProcess(), NULL, 0);

	return TRUE;
}

extern "C"
int APIENTRY DllMain(HMODULE hModule, DWORD fdwReason, LPVOID lpReserved)
{
	return (fdwReason == DLL_PROCESS_ATTACH) ? Hook(hModule) : TRUE;
}

